"use strict";function _interopDefault(t){return t&&"object"==typeof t&&"default"in t?t.default:t}Object.defineProperty(exports,"__esModule",{value:!0});var isPlainObject=_interopDefault(require("lodash/isPlainObject")),isEqual=_interopDefault(require("lodash/isEqual")),url=_interopDefault(require("url"));const messages={forbidden:t=>`${t} is not allowed`,required:t=>`${t} is required`,confirm:(t,e)=>`${e.comparison} must be the same as ${e.initial}`};function __awaiter(t,e,s,r){return new(s||(s=Promise))(function(i,n){function a(t){try{u(r.next(t))}catch(t){n(t)}}function o(t){try{u(r.throw(t))}catch(t){n(t)}}function u(t){t.done?i(t.value):new s(function(e){e(t.value)}).then(a,o)}u((r=r.apply(t,e||[])).next())})}var arrayDiff=(t,e)=>t.filter(t=>-1===e.indexOf(t));function createTest({type:t,func:e=(()=>!1),args:s={}}){return{type:t,func:e,args:s}}function createTestResult(t,e,s){return Object.assign({},t,{valid:e,result:s})}class TypeBase{constructor(t){this.createTest=createTest,this.createTestResult=createTestResult,this.inst=t||require("./index"),this.tests=[],this._required=!1,this._needCast=!1}clone(){const t=Object.assign(Object.create(this),this);return t.tests=this.tests.slice(0),t}test(t,e,s={}){this.tests.push(()=>this.createTest({type:`${this.name}.${t}`,func:e,args:s}))}validate(t,e){return __awaiter(this,void 0,void 0,function*(){const s=(t,e)=>(e&&e(t),t);if(!1===this.presence(t))return!1===this._required?s(!1,e):s(this.createTestResult(this.createTest({type:"required"}),!1),e);this._needCast&&(t=yield this._cast(t));for(var r=0;r<this.tests.length;r++){let i,n=this.tests[r]();if((i=this.testToTestResult(yield n.func(t))).overrideWith&&(n.type=i.overrideWith.type,n.args=i.overrideWith.args),void 0===i.error||void 0===i.valid)throw new Error("test() should return a boolean or an object { valid: boolean, error: string }");if(!i.valid)return s(this.createTestResult(n,i.valid,i),e)}return s(!1,e)})}required(){return this._required=!0,this}cast(){return this._needCast=!0,this}custom(t,e){return this.test(`custom.${t}`,t=>__awaiter(this,void 0,void 0,function*(){try{return yield e(t)}catch(t){return!1}}),{}),this}presence(t){return null!=t&&void 0!==t&&(!("string"==typeof t&&t.length<=0)||!!this._noEmpty)}if({test:t,then:e,otherwise:s}){return this.test("if",r=>__awaiter(this,void 0,void 0,function*(){const i=this.clone();if(i.tests=[],!(yield t(i).validate(r))){i.tests=[];const t=yield e(i).validate(r);return!t||!t.result||Object.assign({},t.result,{overrideWith:t})}i.tests=[];const n=yield s(i).validate(r);return!n||!n.result||Object.assign({},n.result,{overrideWith:n})})),this}testToTestResult(t){return"boolean"==typeof t?{valid:t,error:""}:t}}const messages$1={"object.typeof":t=>`${t} must be a valid object`,"object.in":(t,e)=>`${t} must only contains these keys [${e.in}]`,"object.not":t=>`${t} contains forbidden value`,"object.schema":t=>`${t} has not a valid schema`,"object.oneOf":(t,e,s)=>"oneIsRequired"===s.error?`${t} must contain one of these keys [${e.keys}]`:s.keys?`${t} can not contain these two keys [${s.keys}] at the same time`:"unknown error","object.allOf":(t,e)=>`${t} must contain either none or all of these keys [${e.keys}]`};class TypeObject extends TypeBase{constructor(){super(),this.name="object",this.typeof()}typeof(){return this.test("typeof",t=>isPlainObject(t)),this}in(...t){let e=t,s={oneErrorPerKey:!1};return t.length>0&&Array.isArray(t[0])&&(isPlainObject(t[1])&&(s=Object.assign({},t[1])),e=t[0]),this.test("in",t=>{const r=arrayDiff(Object.keys(t),e);return r.length<=0||!!s.oneErrorPerKey&&{valid:!1,error:"in",errors:r.map(t=>({test:this.createTestResult(this.createTest({type:"forbidden"}),!1),label:t}))}},{in:e}),this}not(...t){let e=t;return 1===t.length&&Array.isArray(t[0])&&(e=t[0]),this.test("not",t=>{return arrayDiff(e,Object.keys(t)).length===e.length},{not:e}),this}schema(t,{returnErrors:e=!0}={}){if(void 0===t.isValidator)throw new Error('schema should be an instance of altheia validator "Alt({ ... })"');return this.test("schema",s=>__awaiter(this,void 0,void 0,function*(){const r=t.clone(),i=yield r.body(s).validate();return{valid:!1===i,error:"schema",errors:i&&e?r._errorsRaw:void 0}}),{schema:t}),this}oneOf(...t){if(t.length<=1)throw new Error("oneOf expect at least 2 params");let e=!1,s=[];return"boolean"==typeof t[0]?(e=t[0],s=t.splice(1)):s=t,this.test("oneOf",t=>__awaiter(this,void 0,void 0,function*(){const r={a:null,b:null};try{Object.keys(t).forEach(t=>{if(s.includes(t))if(r.a){if(!r.b)throw r.b=t,new Error("a and b can not be present at the same time")}else r.a=t})}catch(t){return{valid:!1,error:"exclusion",keys:Object.values(r)}}return!(e&&!r.a&&!r.b)||{valid:!1,error:"oneIsRequired"}}),{oneIsRequired:e,keys:s}),this}allOf(...t){return this.test("allOf",e=>__awaiter(this,void 0,void 0,function*(){return Object.keys(e).reduce((e,s)=>(t.includes(s)&&(e+=1),e),0)===t.length}),{keys:t}),this}}const def={Class:TypeObject,messages:messages$1};class Validator{constructor(t,e){this.inst=e,this.isValidator=1,this.validated=!1,this._schema={},this._body={},this._errors=[],this._errorsRaw=[],this._confirm=[],this._options={required:!1,unknown:!1,flatten:!1},this.schema(t)}clone(){const t=new Validator(this._schema,this.inst);return t.options(this._options),t._confirm=[...this._confirm],t}body(t){return this._body=Object.assign({},t),this}schema(t){if(!isPlainObject(t))throw new Error("schema should be object");return this._schema=t,this}options(t){if(!isPlainObject(t))throw new Error("schema should be object");return this._options=Object.assign(this._options,t),this}formatError(t,e){return this.inst.formatError(t,e)}flatten(t,e){return e.errors?e.errors.reduce(this.flatten,t):(t.push(e),t)}validate(t){return __awaiter(this,void 0,void 0,function*(){if(this.validated)throw new Error("Already validated, please use .clone() to validate a different body");this.validated=!0;const e=(t,e)=>(e&&e(t),t),s=[];if(!1===this._options.unknown){const t=yield(new TypeObject).in(Object.keys(this._schema),{oneErrorPerKey:!0}).validate(this._body);"boolean"!=typeof t&&t.result&&t.result.errors&&t.result.errors.map(t=>s.push(this.formatError(t.test,t.label)))}const r=Object.keys(this._schema);for(var i=0;i<r.length;i++){const t=r[i],e=this._schema[t],n=void 0!==this._body[t]?this._body[t]:null;this._body[t]=n,!0===this._options.required&&e.required();const a=yield e.validate(n);if(!a)continue;this._errorsRaw.push({test:a,label:t});const o=this.formatError(a,t);o.errors&&this._options.flatten?this._options.flatten&&o.errors&&s.push(...o.errors.reduce(this.flatten,[])):s.push(o)}return this._errors=s,this._confirm.length>0&&this._confirm.forEach(t=>{const e=this._body[t.initial],s=this._body[t.comparison];isEqual(e,s)||this._errors.push(this.formatError(createTestResult(createTest({type:"confirm",args:t}),!1),t.comparison))}),s.length>0?e(s,t):e(!1,t)})}confirm(t,e){return this._confirm.push({initial:t,comparison:e}),this}}class TypeAny extends TypeBase{constructor(){super(),this.name="any"}}const def$1={Class:TypeAny},messages$2={"array.typeof":t=>`${t} must be a valid array`,"array.min":(t,e)=>`${t} must contains at least ${e.min} items`,"array.max":(t,e)=>`${t} must contains at most ${e.max} items`,"array.in":(t,e)=>`${t} must only contains these keys [${e.in}]`,"array.not":t=>`${t} contains forbidden value`,"array.unique":t=>`${t} can not contains duplicated value`,"array.oneOf":t=>`${t} contains forbidden items`,"array.itemInvalid":t=>`${t} does not match any of the allowed types`};class TypeArray extends TypeBase{constructor(){super(),this.name="array",this.typeof()}typeof(){return this.test("typeof",t=>Array.isArray(t)),this}min(t){return this.test("min",e=>e.length>=t,{min:t}),this}max(t){return this.test("max",e=>e.length<=t,{max:t}),this}in(...t){let e=t;return 1===t.length&&Array.isArray(t[0])&&(e=t[0]),this.test("in",t=>0===arrayDiff(t,e).length,{in:e}),this}not(...t){let e=t;return 1===t.length&&Array.isArray(t[0])&&(e=t[0]),this.test("not",t=>arrayDiff(e,t).length===e.length,{not:e}),this}unique(){return this.test("unique",t=>{return new Set(t).size===t.length}),this}oneOf(...t){return this.test("oneOf",e=>__awaiter(this,void 0,void 0,function*(){const s=[];return yield Promise.all(e.map((e,r)=>__awaiter(this,void 0,void 0,function*(){let i=void 0;for(var n=0;n<t.length;n++){const s=yield t[n].required().validate(e);if(!s)return;i={label:"item",test:s,position:r}}i&&(t.length>1?(i={label:"item",test:this.createTestResult(this.createTest({type:"array.itemInvalid"}),!1),position:r},s.push(i)):s.push(i))}))),{valid:s.length<=0,error:"not_matching",errors:s}}),{templates:t}),this}}const def$2={Class:TypeArray,messages:messages$2},messages$3={"boolean.typeof":t=>`${t} must be a valid boolean`,"boolean.true":t=>`${t} must be true`,"boolean.false":t=>`${t} must be false`};class TypeBoolean extends TypeBase{constructor(){super(),this.name="boolean",this.typeof()}_cast(t){if("string"==typeof t){if("true"===t||"True"===t)return!0;if("false"===t||"False"===t)return!1}return t}typeof(){return this.test("typeof",t=>"boolean"==typeof t),this}true(){return this.test("true",t=>!0===t),this}false(){return this.test("false",t=>!1===t),this}}const def$3={Class:TypeBoolean,messages:messages$3},iso=new RegExp(/^(?:[-+]\d{2})?(?:\d{4}(?!\d{2}\b))(?:(-?)(?:(?:0[1-9]|1[0-2])(?:\1(?:[12]\d|0[1-9]|3[01]))?|W(?:[0-4]\d|5[0-2])(?:-?[1-7])?|(?:00[1-9]|0[1-9]\d|[12]\d{2}|3(?:[0-5]\d|6[1-6])))(?![T]$|[T][\d]+Z$)(?:[T\s](?:(?:(?:[01]\d|2[0-3])(?:(:?)[0-5]\d)?|24\:?00)(?:[.,]\d+(?!:))?)(?:\2[0-5]\d(?:[.,]\d+)?)?(?:[Z]|(?:[+-])(?:[01]\d|2[0-3])(?::?[0-5]\d)?)?)?)?$/),messages$4={"date.typeof":t=>`${t} must be a valid date`,"date.iso":t=>`${t} must be an ISO-8601 date`,"date.min":(t,{min:e})=>`${t} must be at least ${e.toISOString()}`,"date.max":(t,{max:e})=>`${t} must be less than or equal to ${e.toISOString()}`};class TypeDate extends TypeBase{constructor(){super(),this.name="date",this.typeof()}_cast(t){return Date.parse(t)}typeof(){return this.test("typeof",t=>!isNaN(Date.parse(t))),this}iso(){return this.test("iso",t=>null!==t.match(iso)),this}min(t){return this.test("min",e=>"object"==typeof t&&"Date"===t.constructor.name&&"Invalid Date"!==t.toString()&&Date.parse(e)>=t.getTime(),{min:t}),this}max(t){return this.test("max",e=>"object"==typeof t&&"Date"===t.constructor.name&&"Invalid Date"!==t.toString()&&Date.parse(e)<=t.getTime(),{max:t}),this}}const def$4={Class:TypeDate,messages:messages$4},messages$5={"function.typeof":t=>`${t} must be a valid function`};class TypeFunc extends TypeBase{constructor(){super(),this.name="function",this.typeof()}typeof(){return this.test("typeof",t=>"function"==typeof t),this}}const def$5={Class:TypeFunc,messages:messages$5};var Luhn=(t=>e=>{let s,r=e.length,i=1,n=0;for(;r;)r-=1,s=parseInt(e.charAt(r),10),n+=(i^=1)?t[s]:s;return n&&n%10==0})([0,2,4,6,8,1,3,5,7,9]);const hostname=new RegExp(/^(?=.{1,255}$)[0-9A-Za-z](?:(?:[0-9A-Za-z]|\b-){0,61}[0-9A-Za-z])?(?:\.[0-9A-Za-z](?:(?:[0-9A-Za-z]|\b-){0,61}[0-9A-Za-z])?)*\.?$/),uuidv4=new RegExp(/^[0-9a-f]{8}-?[0-9a-f]{4}-?[1-5][0-9a-f]{3}-?[89ab][0-9a-f]{3}-?[0-9a-f]{12}$/i),ipv4=new RegExp(/^(?!0)(?!.*\.$)((1?\d?\d|25[0-5]|2[0-4]\d)(\.|$)){4}$/),ipv6=new RegExp(/^((?:[0-9A-Fa-f]{1,4}))((?::[0-9A-Fa-f]{1,4}))*::((?:[0-9A-Fa-f]{1,4}))((?::[0-9A-Fa-f]{1,4}))*|((?:[0-9A-Fa-f]{1,4}))((?::[0-9A-Fa-f]{1,4})){7}$/),messages$6={"internet.typeof":t=>`${t} must be a valid string`,"internet.url":t=>`${t} must be a valid url`,"internet.hostname":t=>`${t} must be a valid hostname`,"internet.hex":t=>`${t} must be a valid hex`,"internet.creditCard":t=>`${t} must be a valid Credit Card`,"internet.uuidv4":t=>`${t} must be a valid token`,"internet.ip":t=>`${t} must be a valid IP`,"internet.ipv4":t=>`${t} must be a valid IP v4`,"internet.ipv6":t=>`${t} must be a valid IP v6`};class TypeInternet extends TypeBase{constructor(){super(),this.name="internet",this.typeof()}typeof(){return this.test("typeof",t=>"string"==typeof t),this}url(){return this.test("url",t=>{try{return 0!==t.search("javascript:")&&(new url.URL(t),!0)}catch(t){return!1}}),this}hostname(){return this.test("hostname",t=>null!==t.match(hostname)),this}hex(){return this.test("hex",t=>null!==t.match(/^[a-f0-9]+$/i)),this}creditCard(){return this.test("creditCard",t=>!/[^0-9-\s]+/.test(t)&&(!((t=t.replace(/\D/g,"")).length<13)&&!0===Luhn(t))),this}uuidv4(){return this.test("uuidv4",t=>!(t.length<32)&&uuidv4.test(t)),this}ip(){return this.test("ip",t=>ipv4.test(t)||ipv6.test(t)),this}ipv4(){return this.test("ipv4",t=>ipv4.test(t)),this}ipv6(){return this.test("ipv6",t=>ipv6.test(t)),this}}const def$6={Class:TypeInternet,messages:messages$6},messages$7={"number.typeof":t=>`${t} must be a valid number`,"number.min":(t,e)=>`${t} must be at least ${e.min}`,"number.max":(t,e)=>`${t} must be less than or equal to ${e.max}`,"number.integer":t=>`${t} must be an integer`,"number.unsigned":t=>`${t} must be an unsigned number`,"number.positive":t=>`${t} must be a positive number`,"number.negative":t=>`${t} must be a negative number`,"number.in":(t,e)=>`${t} must be one of [${e.obj}]`,"number.not":t=>`${t} contains forbidden value`};class TypeNumber extends TypeBase{constructor(){super(),this.name="number",this.typeof()}_cast(t){return"string"==typeof t?parseFloat(t):t}typeof(){return this.test("typeof",t=>"number"==typeof t&&!isNaN(t)&&isFinite(t)),this}min(t){return this.test("min",e=>e>=t,{min:t}),this}max(t){return this.test("max",e=>e<=t,{max:t}),this}integer(){return this.test("integer",t=>!0===Number.isSafeInteger(t)),this}unsigned(){return this.test("unsigned",t=>t>=0),this}positive(){return this.test("positive",t=>t>0),this}negative(){return this.test("negative",t=>t<0),this}in(...t){return this.test("in",e=>!0===t.includes(e),{obj:t}),this}not(...t){return this.test("not",e=>!1===t.includes(e),{obj:t}),this}}const def$7={Class:TypeNumber,messages:messages$7},messages$8={"string.typeof":t=>`${t} must be a valid string`,"string.empty":t=>`${t} can not be empty`,"string.min":(t,e)=>`${t} must be at least ${e.min} characters long`,"string.max":(t,e)=>`${t} must be at most ${e.max} characters long`,"string.pattern":(t,e)=>`${t} must match pattern "${e.regex}"`,"string.in":(t,e)=>`${t} must be one of [${e.obj}]`,"string.not":t=>`${t} contains forbidden value`,"string.email":t=>`${t} must be a valid email`,"string.lowercase":t=>`${t} must be lowercase only`,"string.uppercase":t=>`${t} must be uppercase only`};class TypeString extends TypeBase{constructor(){super(),this.name="string",this._noEmpty=!1,this.typeof()}typeof(){return this.test("typeof",t=>"string"==typeof t),this}noEmpty(){return this._noEmpty=!0,this.test("empty",t=>t.length>0),this}min(t){return this.test("min",e=>e.length>=t,{min:t}),this}max(t){return this.test("max",e=>e.length<=t,{max:t}),this}pattern(t){return this.test("pattern",e=>null!==e.match(t),{regex:t}),this}in(...t){return this.test("in",e=>!0===t.includes(e),{obj:t}),this}not(...t){return this.test("not",e=>!1===t.includes(e),{obj:t}),this}email(){return this.test("email",t=>t.search("@")>=0),this}lowercase(){return this.test("lowercase",t=>t.toLocaleLowerCase()===t),this}uppercase(){return this.test("uppercase",t=>t.toLocaleUpperCase()===t),this}}const def$8={Class:TypeString,messages:messages$8},Instance=t=>{const e=t=>new Validator(t,e);return e.langList=Object.assign({},messages),e.templates={},e.Base=TypeBase,e.instance=(t={})=>Instance(Object.assign({},e.langList,t)),e.use=t=>{const s=new t.Class;return e[s.name||s.constructor.name]=()=>new t.Class(e),t.messages&&e.lang(t.messages),e},e.lang=(t,s)=>{isPlainObject(t)?e.langList=Object.assign({},e.langList,t):"string"==typeof t&&s&&(e.langList[t]=s)},e.template=(t,s)=>{e.templates[t]=s},e.is=t=>{if(void 0===e.templates[t])throw new Error(`unknow template ${t}`);return e.templates[t].clone()},e.formatError=({type:t,args:s,result:r},i="value",n)=>{let a;const o={label:i,type:t,message:a=void 0!==e.langList[t]?e.langList[t](i,s,r):"Invalid value"};return"number"==typeof n&&(o.position=n),r&&r.errors&&(o.errors=r.errors.map(t=>e.formatError(t.test,t.label,t.position))),o},e.use(def$1),e.use(def$2),e.use(def$3),e.use(def$4),e.use(def$5),e.use(def$6),e.use(def$7),e.use(def),e.use(def$8),t&&isPlainObject(t)&&e.lang(t),e};var index=Instance();exports.Instance=Instance,exports.default=index;
